package org.caosdb.server.jobs.core;

import java.util.List;
import org.caosdb.server.entity.Message;
import org.caosdb.server.entity.wrapper.Parent;
import org.caosdb.server.entity.wrapper.Property;
import org.caosdb.server.jobs.JobAnnotation;
import org.caosdb.server.jobs.TransactionStage;

@JobAnnotation(stage = TransactionStage.CHECK)
public class InheritInitialState extends EntityStateJob {

  @Override
  protected void run() {
    try {
      State parentState = getFirstParentState();
      if (parentState != null) {
        getEntity().addMessage(parentState);
        parentState.getStateEntity();
        getEntity().setEntityACL(parentState.getStateACL());
      }
    } catch (Message e) {
      getEntity().addError(e);
    }
  }

  private State getFirstParentState() throws Message {
    for (Parent par : getEntity().getParents()) {
      List<Property> stateProperties = getStateProperties(par, false);
      if (stateProperties.size() > 0) {
        return createState(stateProperties.get(0));
      }
    }
    return null;
  }
}
